// WTExtender.cpp : Instantiates the base extender class's static members.
//
#include "stdafx.h"
#include "WTExtender.h"

//////////////////////////////////////////////////////////////////////
// Static base class properties.
//////////////////////////////////////////////////////////////////////
HINSTANCE       CExtenderBase::m_hInstance;       // DLL instance handle.	static HINSTANCE m_hInstance;
CExtenderBase * CExtenderBase::m_pImplementation; // Gives the extern "C" entry points access to object members.

///////////////////////////////////////////////////////////////////////////
//  DLL entry point required by some versions of Microsoft's C/C++ runtime.
//
//  It is used to set the extender class's DLL instance handle for 
//  use by class methods.
///////////////////////////////////////////////////////////////////////////
BOOL WINAPI DllMain(HINSTANCE hInst, DWORD dwReason, LPVOID lpReserved) throw() 
{
   UNREFERENCED_PARAMETER(lpReserved);
	 if (dwReason != DLL_PROCESS_ATTACH)
		return TRUE;

	CExtenderBase::m_hInstance = hInst;
   return TRUE;
}

///////////////////////////////////////////////////////////////////////////
//  DLL Exports required by WIL. (You most likely will not need to change.)
//
//  The WIL DLL doesn't understand exported C++ name mangling so these
//  functions need to remain C naming convention exports.
///////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////

/*===========================================================================

  WILExtenderQuery
  
  WILExtenderQuery is an optional (but recommended) entry point.  It is used
  to provide helpful information to the WIL DLL and possibly other callers.
    
===========================================================================*/
#ifdef UNICODE
extern "C" DllExport LONG FAR PASCAL WILExtenderQueryW(short  nRequest, // type of information being requested
                                                       LPVOID lpvInfo,  // information buffer
                                                       LONG   nCount)   // additional data
#else
extern "C" DllExport LONG FAR PASCAL WILExtenderQuery(short  nRequest, // type of information being requested
                                                      LPVOID lpvInfo,  // information buffer
                                                      LONG   nCount)   // additional data
#endif
{
	return CExtenderBase::m_pImplementation->WILExtenderQuery( nRequest, lpvInfo, nCount);
}

/* =========================================================================
   WIL Extender main entry point.

   All functionality is accessed from here.
   
   ========================================================================= */
#ifdef UNICODE
extern "C" DllExport LONG FAR PASCAL WILExtender2W(HWND            hWnd,                    // HWnd of parent application.
																	HINSTANCE       hInst,                   // HInstance of parent application.
																	LONG            ViperInterfaceVersion,   // WIL interface version.
																	short           CmdId,                   // Identifies extender function being called.
																	LPVIPERCALLBACK lpViperCallback,         // Pointer to return value callback function.
																	LPVIPERSTRUCT   lpViperStruct,           // Pointer to information structure.
																	LPLONG          lpLong,                  // Pointer to your 32 bits.
																	LPVIPERVAR      lpvvArg,                 // Pointer to parameter array.
																	LONG            nArgCount,               // Parameter count for lpvvArg.
																	LPVIPERVAR      lpViperReturn)           // Pointer to return value structure.
#else                   
extern "C" DllExport LONG FAR PASCAL WILExtender2(HWND            hWnd,                    // HWnd of parent application.
                                                  HINSTANCE       hInst,                   // HInstance of parent application.
																  LONG            ViperInterfaceVersion,   // WIL interface version.
																  short           CmdId,                   // Identifies extender function being called.
																  LPVIPERCALLBACK lpViperCallback,         // Pointer to return value callback function.
																  LPVIPERSTRUCT   lpViperStruct,           // Pointer to information structure.
																  LPLONG          lpLong,                  // Pointer to your 32 bits.
																  LPVIPERVAR      lpvvArg,                 // Pointer to parameter array.
																  LONG            nArgCount,               // Parameter count for lpvvArg.
																  LPVIPERVAR      lpViperReturn)           // Pointer to return value structure.
#endif
{
	return CExtenderBase::m_pImplementation->WILExtender2( hWnd, hInst, ViperInterfaceVersion, CmdId, lpViperCallback, lpViperStruct, lpLong, lpvvArg, nArgCount, lpViperReturn);
}

