#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//////////////////////////////////////////////////////////////////////////////////
// Set std:string type.
#ifdef UNICODE
typedef wstring tstring;
#else
typedef string tstring;
#endif

/////////////////////////////////////////////////////////////////////////////////
// The 64-bit integer math extender class.
class CMath64 : public CWilExtenderT<CMath64> 
{
public:
	///////////////////////////////////////////////////
	// ctor/dtor
	CMath64(){}
	~CMath64(){}

	///////////////////////////////////////////////////
	// Required Extender class members.
	LONG Identity( LPVOID lpvInfo, LONG   nCount);
	LONG InterfaceVersion(LPVOID lpvInfo, LONG nCount);
	LONG Initialization(HWND hWnd, HINSTANCE hInst, LPLONG lpLong, LPVIPERVAR lpvvArg, LONG nArgCount);
   LONG LoadTable(HWND hWnd, HINSTANCE hInst, LPLONG lpLong, LPVIPERVAR lpvvArg, LONG nArgCount);
   LONG ShutDown(HWND hWnd, HINSTANCE hInst, LPLONG lpLong, LPVIPERVAR lpvvArg, LONG nArgCount);

	////////////////////////////////////////////////////
	// Extender WIL function implementations.
	LONG m64Add(HWND hWnd, HINSTANCE hInst, LPLONG lpLong, LPVIPERVAR lpvvArg, LONG nArgCount); 
	LONG m64Sub(HWND hWnd, HINSTANCE hInst, LPLONG lpLong, LPVIPERVAR lpvvArg, LONG nArgCount); 
	LONG m64Mul(HWND hWnd, HINSTANCE hInst, LPLONG lpLong, LPVIPERVAR lpvvArg, LONG nArgCount);
	LONG m64Div(HWND hWnd, HINSTANCE hInst, LPLONG lpLong, LPVIPERVAR lpvvArg, LONG nArgCount);
	LONG m64Mod(HWND hWnd, HINSTANCE hInst, LPLONG lpLong, LPVIPERVAR lpvvArg, LONG nArgCount);
	LONG m64Pow(HWND hWnd, HINSTANCE hInst, LPLONG lpLong, LPVIPERVAR lpvvArg, LONG nArgCount);
	LONG m64Rsh(HWND hWnd, HINSTANCE hInst, LPLONG lpLong, LPVIPERVAR lpvvArg, LONG nArgCount);
	LONG m64Lsh(HWND hWnd, HINSTANCE hInst, LPLONG lpLong, LPVIPERVAR lpvvArg, LONG nArgCount);
	LONG m64And(HWND hWnd, HINSTANCE hInst, LPLONG lpLong, LPVIPERVAR lpvvArg, LONG nArgCount);
	LONG m64Or (HWND hWnd, HINSTANCE hInst, LPLONG lpLong, LPVIPERVAR lpvvArg, LONG nArgCount);
	LONG m64Xor(HWND hWnd, HINSTANCE hInst, LPLONG lpLong, LPVIPERVAR lpvvArg, LONG nArgCount);
	LONG m64Not(HWND hWnd, HINSTANCE hInst, LPLONG lpLong, LPVIPERVAR lpvvArg, LONG nArgCount);
	LONG m64Conv(HWND hWnd, HINSTANCE hInst, LPLONG lpLong, LPVIPERVAR lpvvArg, LONG nArgCount);
	LONG m64GetInfo(HWND hWnd, HINSTANCE hInst, LPLONG lpLong, LPVIPERVAR lpvvArg, LONG nArgCount);

	// Conversion constants use by m64Conv. 
	enum m64ConvTo : int {
		m64ToDec = 10,
		m64ToHex = 16
	};

protected:
	////////////////////////////////////////////////////
	// Untility members.
	INT64 StrToInt64( LPTSTR pszNumber, int nBase = 10);
	INT64 IntPow( INT64 nBase, int nExponent); 

	inline LPTSTR ArgTStr(vipervar & vvArg)

	{
#ifdef UNICODE
		return vvArg.lpwstr;
#else
		return vvArg.lpstr;
#endif
	}

protected:
	///////////////////////////////////////////////////
	// Properties.
	DWORD dwLastError;        // Extender error number. 

};

//////////////////////////////////////////////////////////////////////////////////////
// 64-bit Math Extender utility classes.
/////////////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////////
// User locale class for string to number and number to string conversions.
class CNumLocale {
public:
	~CNumLocale()
	{
		Restore();
	}
	void SetToEnvironment()
	{
		// Save current locale.
		Default = _tsetlocale(LC_NUMERIC, NULL);

		// Set the locale to environment's default locale.
		_tsetlocale(LC_NUMERIC, _T("")); 
	}
	void Restore()
	{
		if ( !Default.empty() ) {
			_tsetlocale(LC_NUMERIC, Default.c_str());
			Default.clear();
		}
	}

protected:
	tstring Default;
};

/////////////////////////////////////////////////////////////////////////////////
// Wrapper class for CRT's errno. Use to throw errno exceptions.
class CErrnoException {
private:
   CErrnoException() {}  // Avoid uninitialized construction.
   int m_nErrno; // CRT errno value.
public:
   CErrnoException( CErrnoException& e) : m_nErrno(e.m_nErrno) {}  // Copy constructor.
   CErrnoException( int n) : m_nErrno(n) {}                        // Initializing constructor.
   ~CErrnoException() {}
   int GetErrno() { return m_nErrno; }
};

